purpose: Access primitives for descriptor tables.

\ Far pointers to the beginnings of descriptor tables
\ "farp" is "offset selector"

defer idt  ( -- farp )
defer gdt  ( -- farp )
defer ldt  ( -- farp )
defer environ-ptr  ( -- farp )

: (ldt)    ( -- farp )  0  ldtr@  ;
' (ldt) is ldt

\ Add an offset to a far pointer.
: far+  ( farp-offset farp-sel offset -- farp-offset' farp-sel )  rot + swap  ;

\ Fetch and store far pointers
: farp@  ( adr -- offset sel )  dup le-l@  swap la1+ le-w@  ;
: farp!  ( offset sel adr -- )  tuck la1+ le-w!  le-l!  ;

\ 4-byte far access
: far-l@  ( farp -- l )  spacel@  ;
: far-l!  ( l farp -- )  spacel!  ;

\ 8-byte far access
: far-x@  ( farp -- ls ms )  2dup far-l@  -rot  4 far+ far-l@  ;
: far-x!  ( ls ms farp -- )  rot 2 pick 2 pick 4 far+  far-l!  far-l!  ;
